const int relay = 12;
const int pir = 2;
const int delayTime = 1000;  // Delay in milliseconds

unsigned long lastOnTime;   // Time of last off-to-on transition
unsigned long lastOffTime;  // Time of last on-to-off transition
int pirState;

void setup() {
  pinMode(relay, OUTPUT);
  pinMode(  pir,  INPUT);
  digitalWrite(relay, LOW);
  pirState = digitalRead(pir);
  lastOnTime = lastOffTime = millis();
}

void loop() {
  // Implementation based on one of the participant's suggestions.
  // Assumes that within delayTime,
  //   there is at most one change in movement detection.
  unsigned long now = millis();
  if (digitalRead(pir)==HIGH){
    if (pirState==LOW) {
      lastOnTime = now;
      pirState = HIGH;
    }
  } else {
    if (pirState==HIGH) {
      lastOffTime = now;
      pirState = LOW;
    }
  }
  // All four states are explictly listed out for better illustration.
  if (now-lastOffTime<delayTime && now-lastOnTime<delayTime) {
    // Do nothing so as to keep the state of the relay the same
  }
  if (now-lastOffTime>=delayTime && now-lastOnTime<delayTime) {
    // There was a off-to-on transition but delay is not long enough
    digitalWrite(relay, LOW);
  }
  if (now-lastOffTime<delayTime && now-lastOnTime>=delayTime) {
    // There was a on-to-off transition but delay is not long enough
    digitalWrite(relay, HIGH);
  }
  if (now-lastOffTime>=delayTime && now-lastOnTime>=delayTime) {
    // Both on-to-off and off-to-on transitions are in the past
    if (lastOffTime<lastOnTime) {
      // Set output to high if last transition is an off-to-on transition
      digitalWrite(relay, HIGH);
    } else {
      // Set output to low if last transition is an on-to-off transition
      digitalWrite(relay, LOW);
    }
  }
}

